<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Recherche de la matière concernée
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT id, cle, nom FROM matieres WHERE agenda = 1');
if ( !empty($_REQUEST) )  {
  while ( $r = $resultat->fetch_assoc() )
    if ( isset($_REQUEST[$r['cle']]) )  {
      $matiere = $r;
      break;
    }
}
// Matière par défaut : la première
if ( !isset($matiere) )  {
  $resultat->data_seek(0);
  $matiere = $resultat->fetch_assoc();
}
$resultat->free();

// Récupération des types et fabrication du Select correspondant
$resultat = $mysqli->query("SELECT id, nom FROM `agenda-types`");
$select_types = '';
while ( $r = $resultat->fetch_assoc() ) {
  $select_types .= "        <option value=\"${r['id']}\">${r['nom']}</option>\n";
  $types[$r['id']] = $r['nom'];
}
$resultat->free();
$mysqli->close();

// Select sur les jours de la semaine
$semaine = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
$select_jours = '';
foreach ( $semaine as $i=>$s)
  $select_jours .= "        <option value=\"$i\">$s</option>\n";

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('agenda-boutons');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Pour déplacement et suppression : vérification de l'existence
  if ( isset($_REQUEST['monte']) || isset($_REQUEST['suppr']) )  {
    $resultat = $mysqli->query("SELECT nom FROM `agenda-boutons` WHERE id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $nom = $r[0];
      $resultat->free();

      // Déplacement
      if ( isset($_REQUEST['monte']) )
        $message = ( $mysqli->query("UPDATE `agenda-boutons` SET id = 0 WHERE id = $n AND matiere = ${matiere['id']}")
                  && $mysqli->query("UPDATE `agenda-boutons` SET id = ($n-1+id/($n-1)) WHERE ( id = ($n-1) OR id = 0 ) AND matiere = ${matiere['id']} ORDER BY id DESC")
                  && $mysqli->query("ALTER TABLE `agenda-boutons` ORDER BY id,matiere")
        ) ? "Le raccourci «&nbsp;$nom&nbsp;» a bien été monté d'une place." : "Le raccourci «&nbsp;$nom&nbsp;» n'a pas pu être déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Suppression
      elseif ( isset($_REQUEST['suppr']) )
        $message = ( $mysqli->query("DELETE FROM `agenda-boutons` WHERE id = $n AND matiere = ${matiere['id']}")
                  && $mysqli->query("UPDATE `agenda-boutons` SET id = (id-1) WHERE id > $n AND matiere = ${matiere['id']}")
        ) ? "Le raccourci «&nbsp;$nom&nbsp;» a bien été supprimé." : "Le raccourci «&nbsp;$nom&nbsp;» n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  // Ajout/modification d'un bouton
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un raccourci sans nom. Pour supprimer un raccourci, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $jour = ( is_numeric($_POST['jour']) && array_key_exists($_POST['jour'],$semaine) ) ? $_POST['jour'] : 1; ;
      $h_debut = preg_replace('/(\d{2})-(\d{2})/','$1-$2',$_REQUEST['h_debut']);
      $h_fin = preg_replace('/(\d{2})-(\d{2})/','$1-$2',$_REQUEST['h_fin']);
      $type = ( is_numeric($_POST['type']) && array_key_exists($_POST['type'],$types) ) ? $_POST['type'] : 1;
      $demigroupe = ( isset($_REQUEST['demigroupe']) ) ? 1 : 0;
      // Si n > 0 : modification d'un item existant. Si n = 0, nouvel item
      if ( $n )
        $message = ( $mysqli->query("UPDATE `agenda-boutons` SET jour = $jour, nom = '$nom', h_debut = '$h_debut', h_fin = '$h_fin',
                                     type = $type, demigroupe = $demigroupe WHERE id = $n AND matiere = ${matiere['id']}")
        ) ? "Le raccourci «&nbsp;$nom&nbsp;» a bien été modifié." : "Le raccourci «&nbsp;$nom&nbsp;» n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      else
        $message = ( $mysqli->query("UPDATE `agenda-boutons` SET id = (id+1) WHERE matiere = ${matiere['id']} ORDER by id DESC")
                  && $mysqli->query("INSERT INTO `agenda-boutons` SET id = 1, matiere = ${matiere['id']}, jour = $jour, nom = '$nom',
                                     h_debut = '$h_debut', h_fin = '$h_fin', type = $type, demigroupe = $demigroupe")
                  && $mysqli->query("ALTER TABLE `agenda-boutons` ORDER BY id,matiere")
        ) ? "Le raccourci «&nbsp;$nom&nbsp;» a bien été ajouté." : "Le raccourci «&nbsp;$nom&nbsp;» n'a pas pu être ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  $mysqli->close();
}

// Fonction d'affichage du formulaire
function affiche_formulaire($r)  {
  $sj = str_replace("\"${r['jour']}\"","\"${r['jour']}\" selected",$GLOBALS['select_jours']);
  $st = str_replace("\"${r['type']}\"","\"${r['type']}\" selected",$GLOBALS['select_types']);
  $suppr = ( $r['id'] ) ? '<input type="submit" name="suppr" value="Supprimer">' : '';
  $monte = ( $r['id'] > 1 ) ? '<input type="submit" name="monte" value="&uarr;" title="Remonter le raccourci dans l\'ordre d\'apparition">' : '';
  $titre = ( $r['id'] ) ? '' : "\n    <h3>Ajout d'un nouveau raccourci</h3>\n";
  echo <<<FIN
  <form action="" method="post" class="item admin">$titre
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr$monte</p>
    <p>Nom affiché du raccourci&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"></p>
    <p>
      Type&nbsp;: <select name="type">
$st     </select> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Jour&nbsp;: <select name="jour">
$sj      </select>
    </p>
    <p>
      Heure de début&nbsp;: <input type="text" class="heure" name="h_debut" value="${r['hd']}" size="5"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Heure de fin&nbsp;: <input type="text" class="heure" name="h_fin" value="${r['hf']}" size="5"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      En demi-groupe&nbsp;: <input type="checkbox" name="demigroupe" value="1"${r['dg']}>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </p>
  </form>


FIN;
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = "agenda-boutons?${matiere['cle']}";
$t = "Cahier de texte de ${matiere['nom']}&nbsp;: modification des raccourcis";
$menusupp = '';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";
?>
  <div class="item">
    <p>Vous pouvez ici ajouter ou modifier des boutons de raccourci, qui s'afficheront dans votre page de modification du cahier de texte. Ces boutons vous permettent de régler en un clic l'horaire de la séance, le type de séance ainsi que le jour de la semaine. Si par exemple vous choisissez «&nbsp;Lundi&nbsp;», lorsque vous l'utiliserez dans votre cahier de texte, le dernier lundi qui vient de passer sera automatiquement sélectionné.</p>
    <p>Vous pouvez créer autant de raccourcis que vous le souhaitez.</p>
  </div>

<?php
// Affichage d'un formulaire vide pour ajout
affiche_formulaire(array('id'=>0,'nom'=>'','jour'=>1,'type'=>1,'hd'=>'08:30','hf'=>'10:30','dg'=>''));

// Récupération et affichage des raccourcis
$resultat = $mysqli->query("SELECT id, nom, jour, type, TIME_FORMAT(h_debut,'%H:%i') AS hd,
                            TIME_FORMAT(h_fin,'%H:%i') AS hf, IF(demigroupe=1,' checked', '') AS dg
                            FROM `agenda-boutons` WHERE matiere = ${matiere['id']}");
if ( $resultat->num_rows )  {
?>
  <h2>Boutons existants</h2>

  <div class="item">
    <p>Il est possible de modifier l'ensemble des données relatives à chaque bouton, mais aussi l'ordre l'ordre des types d'entrées&nbsp;: cela modifie leur ordre d'apparition dans le menu ainsi que dans l'interface administrative des cahiers de texte.</p>
  </div>
  
<?php
  while ( $r = $resultat->fetch_assoc() )
    affiche_formulaire($r);
  $resultat->free();
}
$mysqli->close();
?>

  <script type="text/javascript">
$( function() {  $('.heure').timeEntry({timeSteps: [1, 30, 0]});  });
  </script>

<?php
// Bas de page
include('bas.php');
?>

