<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('agenda-types');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Pour déplacement et suppression : vérification de l'existence et récupération de l'ordre
  if ( isset($_REQUEST['monte']) || isset($_REQUEST['suppr']) )  {
    $resultat = $mysqli->query("SELECT ordre,nom FROM `agenda-types` WHERE id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $ordre = $r[0];
      $nom = $r[1];
      $resultat->free();

      // Déplacement
      if ( isset($_REQUEST['monte']) )
          $message = ( $mysqli->query("UPDATE `agenda-types` SET ordre = (2*$ordre-1-ordre) WHERE ordre = $ordre OR ordre = ($ordre-1)")
                    && $mysqli->query('ALTER TABLE `agenda-types` ORDER BY ordre')
        ) ? "Le type d'entrée «&nbsp;$nom&nbsp;» a bien été monté d'une place." : "Le type d'entrée «&nbsp;$nom&nbsp;» n'a pas pu être déplacé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Suppression
      elseif ( isset($_REQUEST['suppr']) )  {
        // Vérification que cela ne va pas impacter des entrées dans les cahiers de texte
        $resultat = $mysqli->query("SELECT id FROM agenda WHERE type = $n");
        if ( $resultat->num_rows )  {
          $message = "Le type d'entrée «&nbsp;$nom&nbsp;» n'a pas pu être supprimé car des entrées dans les cahiers de texte (toutes matières confondues) sont de ce type.";
          $resultat->free();
        }
        else
          $message = ( $mysqli->query("DELETE FROM `agenda-types` WHERE id = $n")
                    && $mysqli->query("UPDATE `agenda-types` SET ordre = (ordre-1) WHERE ordre > $ordre")
          ) ? "Le type d'entrée «&nbsp;$nom&nbsp;» a bien été supprimé." : "Le type d'entrée «&nbsp;$nom&nbsp;» n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
    }
  }
  // Ajout/modification d'un type
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider un type sans clé ou sans nom. Pour supprimer une type, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $h_fin = ( isset($_REQUEST['h_fin']) ) ? 1 : 0;
      // Si n > 0 : modification d'un type existant. Si n = 0, nouveau type
      if ( $n )
        $message = ( $mysqli->query("UPDATE `agenda-types` SET cle = '$cle', nom = '$nom', titre = '$titre', h_fin = $h_fin  WHERE id = $n")
        ) ? "Le type d'entrée «&nbsp;$nom&nbsp;» a bien été modifié." : "Le type d'entrée «&nbsp;$nom&nbsp;» n'a pas pu être modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      else
        $message = ( $mysqli->query("INSERT INTO `agenda-types` SET cle = '$cle', nom = '$nom', titre = '$titre', h_fin = $h_fin, ordre = ((SELECT MAX(m.ordre) FROM `agenda-types` AS m)+1)")
                  && $mysqli->query('ALTER TABLE `agenda-types` ORDER BY ordre')
        ) ? "Le type d'entrée «&nbsp;$nom&nbsp;» a bien été ajouté." : "Le type d'entrée «&nbsp;$nom&nbsp;» n'a pas pu être ajouté. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = 'agenda-types';
$t = 'Modifications des types d\'entrées des cahiers de texte';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Description et formulaire vide pour ajout
?>
  <div class="item">
    <p>Les différents types d'entrées pour l'ensemble des cahiers de texte peuvent être définis ici. Il s'agit des tyes de séances (cours, td, tp, ds...) mais aussi de tout ce qui peut être indiqué dans un cahier de texte (dm, interrogation, distribution de document...).</p>
    <p>Créer des types d'entrées variés et explicites permet d'augmenter la lisibilité des cahiers de texte et la facilité de rechercher une entrée à l'intérieur.</p>
  </div>
  
  <form action="" method="post" class="item admin">
    <h3>Ajout d'un nouveau type d'entrée</h3>
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
    <h4>Nom complet&nbsp;: <input type="text" name="nom" value="" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="" size="20">
    </h4>
    <h4>Titre des entrées&nbsp;: <input type="text" name="titre" value="" size="60"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Afficher l'heure de fin&nbsp;: <input type="checkbox" name="h_fin" value="1" checked>
      <input type="hidden" name="nmodif" value="0">
    </h4>
  </form>

  <div class="item">
    <p>Le nom complet est le nom correspondant à ce type d'entrées, qui sera affiché entre autres dans le menu. Il est plus logique que ce soit au pluriel. Par exemple, «&nbsp;Devoirs surveillés&nbsp;», «&nbsp;Travaux dirigés&nbsp;».</p>
    <p>La clé est un mot-clé qui sera utilisé uniquement dans les adresses web vers les entrées correspondantes&nbsp;: «&nbsp;<code>http://<?php echo $site; ?>/agenda?[matière]&amp;type=[cle]</code>&nbsp;» permet d'afficher toutes les entrées de type [clé] de la [matière]. Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;ds&nbsp;», «&nbsp;td&nbsp;».</p>
    <p>Le titre sera ce qui est affiché au début de chaque entrée de ce type dans les cahiers de texte à côté de la date et de l'heure. On peut mettre un énoncé un peu plus long que le nom, a priori au singulier. Par exemple, «&nbsp;Devoir surveillé&nbsp;», «&nbsp;Séance de travaux dirigés&nbsp;».</p>
    <p>La case «&nbsp;Afficher l'heure de fin&nbsp;» permet de choisir si pour les entrées de ce type, l'horaire est affiché comme «&nbsp;début-fin&nbsp;» ou comme «&nbsp;début&nbsp;». Cela peut être utilisé pour des événements ne prenant que quelques minutes, comme des interrogations de cours ou distributions de documents. Si elle est décochée, seul l'horaire du début sera alors affiché.</p>
  </div>
  
<?php
// Récupération et affichage des types
$resultat = $mysqli->query('SELECT at.id, at.ordre, at.cle, at.nom, at.titre, IF(at.h_fin=1,\' checked\', \'\') AS h_fin, COUNT(a.id) AS c
                            FROM `agenda-types` AS at LEFT JOIN agenda AS a ON at.id = a.type GROUP BY at.id ORDER by at.ordre');
if ( $resultat->num_rows )  {
?>
  <h2>Types d'entrées existants</h2>

  <div class="item">
    <p>Ces types d'entrées sont utilisés par chaque cahier de texte de chaque matière&nbsp;: les modifications effectuées ici impactent toutes les matières. C'est pourquoi il est impossible de supprimer un type d'entrées si dans un des cahiers de texte une seule entrée est de ce type.</p>
    <p>Modifier des clés changera les adresses web correspondantes et pourrait éventuellement affecter des liens qui auraient été écrits à la main (cela est très peu probable). Les liens générés automatiquement comme ceux du menu seront immédiatement modifiés.</p>
    <p>Modifier les noms ou les titres changera l'affichage du site, dans le menu et/ou dans les cahiers de texte de l'ensemble des matières.</p>
    <p>Il est aussi possible de modifier l'ordre des types d'entrées&nbsp;: cela modifie leur ordre d'apparition dans le menu ainsi que dans l'interface administrative des cahiers de texte.</p>
  </div>
  
<?php
  while ( $r = $resultat->fetch_assoc() )  {
    $monte = ( $r['ordre'] > 1 ) ? '<input type="submit" name="monte" value="&uarr;" title="Remonter le type dans l\'ordre d\'apparition dans le menu">' : '';
    $suppr1 = ( $r['c'] ) ? '' : '<input type="submit" name="suppr" value="Supprimer">';
    $suppr2 = ( $r['c'] ) ? "\n    <p class=\"note\">Note&nbsp;: Ce type d'entrée ne peut pas être supprimé car il correspond à ${r['c']} entrée(s) dans les cahiers de texte (toutes matières confondues).</p>" : '';
    echo <<<FIN
  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr1$monte</p>
    <h4>Nom complet&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="${r['cle']}" size="20">
    </h4>
    <h4>Titre des entrées&nbsp;: <input type="text" name="titre" value="${r['titre']}" size="60"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Afficher l'heure de fin&nbsp;: <input type="checkbox" name="h_fin" value="1"${r['h_fin']}>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </h4>$suppr2
  </form>


FIN;
  }
  $resultat->free();
}
else
  echo "  <h4 class=\"warning\">Aucun type d'entrées n'est encore défini&nbsp;: la fonction de cahier de texte n'est actuellement pas utilisable.</h4>\n\n";
$mysqli->close();

// Bas de page
include('bas.php');
?>

