<?php
// Sécurité et récupération des données de configuration
define('OK',1);
include('debut.php');

// Récupération du nombre de colles de l'année
$mysqli = premiere_connexion();
$resultat = $mysqli->query('SELECT MAX(colle) FROM semaines');
$r = $resultat->fetch_row();
$nmax = $r[0];
$resultat->free();
// Si pas de planning enregistré
if ( !$nmax )  {
  $mysqli->close();
  include('installation.php');
}

// Recherche de la matière concernée
$resultat = $mysqli->query('SELECT id, cle, nom FROM matieres WHERE colles = 1');
$mysqli->close();
if ( $resultat->num_rows )  {
  if ( !empty($_REQUEST) )  {
    while ( $r = $resultat->fetch_assoc() )
      if ( isset($_REQUEST[$r['cle']]) )  {
        $matiere = $r;
        break;
      }
  }
  // Matière par défaut : la première
  if ( !isset($matiere) )  {
    $resultat->data_seek(0);
    $matiere = $resultat->fetch_assoc();
  }
  $resultat->free();
}
// Si aucune matière présentant son programme de colles n'est enregistrée
else
  exit('<h2>Cette page ne contient aucune information.</h2>');
        
// Pour l'interface d'administration
if ( $admin )  {
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Traitement d'un ajout/modification/transformation
  if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) && ( $n <= $nmax ) )  {
    // Sauvegarde de la table contenant les données
    sauvegarde_mysql('colles');

    // Suppression
    if ( isset($_REQUEST['suppr']) )
      $message = ( $mysqli->query("DELETE FROM colles WHERE id = $n AND matiere = ${matiere['id']}") ) ? "Le programme de la semaine $n a bien été supprimé." : "Le programme de la semaine $n n'a pas pu être supprimé. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    // Ajout/modification d'une colle
    else  {
      if ( isset($_REQUEST['valid_modif']) )  {
        if ( !strlen($_REQUEST['texte']) )
          $message = 'Il n\'est pas possible de valider un texte vide. Pour supprimer un programme de colles, il faut cliquer sur Supprimer.';
        else  {
          // Vérification du numéro de semaine
          $resultat = $mysqli->query("SELECT colle FROM semaines WHERE colle = $n AND pascolle = 0");
          if ( $resultat->num_rows )  {
            $resultat->free();
            $texte = $mysqli->real_escape_string($_REQUEST['texte']);
            $message = ( $mysqli->query("INSERT INTO colles SET id = $n, texte = '$texte', matiere = ${matiere['id']} ON DUPLICATE KEY UPDATE texte = '$texte'")
                      && $mysqli->query('ALTER TABLE colles ORDER BY id,matiere')
            ) ? "Le programme de la semaine $n a bien été ajouté/modifié." : "Le programme de la semaine $n n'a pas pu être ajouté/modifié. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
          }
          else  {
            $message = "Le programme de la semaine $n n'a pas pu être ajouté/modifié car $n n'est pas un numéro de semaine valide.";
            $texte = $_REQUEST['texte'];
          }
        }
      }
      // Lecture pour affichage dans le formulaire
      $resultat = $mysqli->query("SELECT texte FROM colles WHERE id = $n AND matiere = ${matiere['id']}");
      if ( $resultat->num_rows )  {
        $r = $resultat->fetch_row();
        $texte = $r[0];
        $resultat->free();
      }
    }
  }

  // Conditionnement du message éventuel
  $message = ( isset($message) ) ? "<p class=\"annonce\">$message</p>\n\n" : '';

  // Initialisation des variables pour le formulaire
  if ( !isset($texte) || isset($_REQUEST['copie']) )  {
    $suppr = '';
    $resultat = $mysqli->query("SELECT MAX(id) FROM colles WHERE matiere = ${matiere['id']}");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $n = $r[0]+1;
      $resultat->free();
    }
    else
      $n = 1;
  }
  else
    $suppr = '<input type="submit" name="suppr" value="Supprimer">';
  if ( !isset($texte) )
    $texte = '&lt;p&gt;Texte&lt;/p&gt;';
  $mysqli->close();
  
  // Formulaire d'ajout/modification
  $formulaire = <<<FIN
  $message<div class="item">
    <p>Vous pouvez ici ajouter un programme de colles pour une semaine donnée. Il est aussi possible de faire apparaître en-dessous de ce formulaire des semaines déjà entrées grâce au menu, et de les modifier par la suite.</p>
    <p>Les semaines sont identifiées par leur numéro. Pour connaître ou modifier la correspondance entre les dates et les numéros de semaines, vous devez vous rendre sur la <a href="semaines">page de modification des semaines</a>.</p>
  </div>
  
  <!-- Formulaire de modification/copie -->
  <form class="item admin" action="" method="post">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr</p>
    <h3>Semaine n°<input type="text" name="nmodif" size=3 maxlength=2 value="$n"></h3>
    <h4>Programme&nbsp;:</h4>
    <div><textarea name="texte" rows="25" cols="100">$texte</textarea></div>
  </form>

  <script type="text/javascript" src="js/textarea.js"></script>

  <div class="item">
    <p>Les programmes des semaines affichés ci-dessous sont modifiables. Il est possible de faire apparaître d'autres semaines déjà entrées grâce au menu.</p>
    <p>Le bouton «&nbsp;Recopier&nbsp;» récupère le programme de colles concerné et permet d'en créer un nouveau sur le même modèle&nbsp;: le programme original ne sera pas modifié après l'édition dans le formulaire de modification.</p>
  </div>


FIN;
  unset($n);
}

// Supplément au menu : toutes les semaines de colles existantes
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
$resultat = $mysqli->query("SELECT id FROM colles WHERE matiere = ${matiere['id']}");
if ( $resultat->num_rows )  {
  $menusupp = "    <h4>Semaines de colles</h4>\n    <p class=\"menusupp\">\n";
  while ( $r = $resultat->fetch_row() )
    $menusupp .= "      <a class=\"ligne\" href=\"colles?${matiere['cle']}&amp;n=${r[0]}$urladmin\">${r[0]}</a>&nbsp;-\n";
  $resultat->free();
  $menusupp = substr($menusupp,0,strlen($menusupp)-8)."    </p>\n";
}
else
  $menusupp = '';

//////////
// HTML //
//////////
// Haut de page et menu
$p = "colles?${matiere['cle']}";
$t = "Programme de colles - ${matiere['nom']}";
include('haut.php');

// Formulaire éventuel de modification/ajout
if ( isset($formulaire) )
  echo $formulaire;

// Récupération du premier jour à afficher
if ( isset($_REQUEST['n']) && is_numeric($_REQUEST['n']) && ( $_REQUEST['n'] <= $nmax ) )  {
  $resultat = $mysqli->query("SELECT lundi FROM semaines WHERE colle = ${_REQUEST['n']} LIMIT 1");
  if ( $resultat->num_rows )  {
    $r = $resultat->fetch_row();
    $premierlundi = $r[0];
    $n = $_REQUEST['n'];
    $resultat->free();
    // Par défaut (affichage d'une semaine seule), $nb=1
    $nb = ( isset($_REQUEST['nb']) && is_numeric($_REQUEST['nb']) ) ? max(1,$_REQUEST['nb']) : 1;
  }
}
// Si n n'est pas demandé ou est faux, recherche de la semaine "actuelle"
// 'lundi' sera le dernier lundi passé, 'colle' le numéro de la prochaine colle (NULL si l'année est finie)
// Pas de résultat si l'année n'a pas encore commencé
if ( !isset($n) )  {
  $resultat = $mysqli->query('SELECT lundi, IF(pascolle=0,colle,(SELECT colle FROM semaines WHERE lundi > ADDDATE(NOW(),2) AND pascolle = 0 LIMIT 1)) AS colle
                             FROM semaines WHERE lundi < ADDDATE(NOW(),3) ORDER BY lundi DESC LIMIT 1');
  if ( $resultat->num_rows )  {
    $r = $resultat->fetch_assoc();
    $premierlundi = $r['lundi'];
    $n = is_null($r['colle']) ? $nmax : $r['colle'];
    $resultat->free();
    // Par défaut (affichage d'une semaine seule), $nb=1
    $nb = ( isset($_REQUEST['nb']) && is_numeric($_REQUEST['nb']) ) ? max(1,$_REQUEST['nb']) : 2;
  }
}

if ( isset($n) )  {
  // Récupération des $nb semaines (semaine demandée et semaines suivantes, hors vacances et semaines sans colles)
  $requete_fin = ( isset($n) && ( $n+$nb <= $nmax ) ) ? "AND semaines.lundi <= (SELECT lundi FROM semaines WHERE semaines.colle = ($n+$nb-1) LIMIT 1)" : '';
  $resultat = $mysqli->query("SELECT DATE_FORMAT(semaines.lundi,'%w') AS j, DATE_FORMAT(semaines.lundi,'%e/%m') AS jour, semaines.pascolle, semaines.colle, colles.texte 
                              FROM semaines LEFT JOIN (SELECT * FROM colles WHERE matiere = ${matiere['id']}) AS colles ON semaines.colle=colles.id
                              WHERE semaines.lundi >= '$premierlundi' $requete_fin");

  // Affichage des programmes demandés
  $semaine = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
  while ( $r = $resultat->fetch_assoc() )  {
    switch ( $r['pascolle'] )  {
      case 0:
        $aff = "  <h3>Semaine n°${r['colle']} - ${semaine[$r['j']]} ${r['jour']}</h3>\n\n";
        if ( is_null($r['texte']) )
          $aff .= "  <h4>Le programme de colles de cette semaine n'est pas défini.</h4>\n";
        else  {
          if ( $admin )
            $aff .= <<<FIN
  <form class="bouton_ok" action="" method="post"><div>
    <input type="submit" name="copie" value="Recopier" title="Prendre le texte de cette semaine et le positionner dans le formulaire comme s'il s'agissait d'une nouvelle semaine">
    <input type="submit" name="modif" value="Modifier/Supprimer" title="Afficher la semaine et demander une modification ou une suppression">
    <input type="hidden" name="nmodif" value="${r['colle']}">
  </div></form>

${r['texte']}
FIN;
          else  $aff .= $r['texte'];
        }
        break;
      case 1:
        $aff = '  <h3>Semaine du '.strtolower($semaine[$r['j']])." ${r['jour']}</h3>\n<h4>Pas de colles cette semaine</h4>";
        break;
      case 2:
        $aff = "  <h3>${semaine[$r['j']]} ${r['jour']}&nbsp;: Vacances de Toussaint</h3>";
        break;
      case 3:
        $aff = "  <h3>${semaine[$r['j']]} ${r['jour']}&nbsp;: Vacances de Noël</h3>";
        break;
      case 4:
        $aff = "  <h3>${semaine[$r['j']]} ${r['jour']}&nbsp;: Vacances d'hiver</h3>";
        break;
      case 5:
        $aff = "  <h3>${semaine[$r['j']]} ${r['jour']}&nbsp;: Vacances de Pâques</h3>";
        break;
      case 6:
        $aff = '  <h3>Fin des colles pour cette année.</h3>';
    }
    // Affichage
    echo "  <!-- Nouvelle semaine -->\n  <div class=\"item colle\">\n\n$aff\n\n  </div>\n\n";
  }
  $resultat->free();
  // Liens de navigation vers semaines précédentes/suivantes
  if ( $n > 1 )
    echo "  <a id=\"prec\" href=\"?${matiere['cle']}&amp;n=". max(1,$n-$nb) ."&amp;nb=$nb$urladmin\">Semaines précédentes</a>\n\n";
  if (  $n+$nb <= $nmax )
    echo "  <a id=\"suiv\" href=\"?${matiere['cle']}&amp;n=". ($n+$nb) ."&amp;nb=$nb$urladmin\">Semaines suivantes</a>\n\n";
}
else
  echo "  <h2>L'année n'a pas encore commencé... Revenez à la rentrée&nbsp;!</h2>\n\n";

$mysqli->close();

// Bas de page
include('bas.php');
?>

