<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('pages');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');

  // Pour déplacement et suppression : vérification de l'existence et récupération de l'ordre
  if ( isset($_REQUEST['monte']) || isset($_REQUEST['suppr']) )  {
    $resultat = $mysqli->query("SELECT ordre,nom FROM pages WHERE id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $ordre = $r[0];
      $nom = $r[1];
      $resultat->free();

      // Déplacement
      if ( isset($_REQUEST['monte']) )
        $message = ( $mysqli->query("UPDATE pages SET ordre = (2*$ordre-1-ordre) WHERE ordre = $ordre OR ordre = ($ordre-1)")
                  && $mysqli->query('ALTER TABLE pages ORDER BY ordre')
        ) ? "La page «&nbsp;$nom&nbsp;» a bien été montée d'une place." : "La page «&nbsp;$nom&nbsp;» n'a pas pu être déplacée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      // Suppression
      elseif ( isset($_REQUEST['suppr']) )
        $message = ( $mysqli->query("DELETE FROM pages WHERE id = $n")
                  && $mysqli->query("UPDATE pages SET ordre = (ordre-1) WHERE ordre > $ordre")
        ) ? "La page «&nbsp;$nom&nbsp;» a bien été supprimée." : "La page «&nbsp;$nom&nbsp;» n'a pas pu être supprimée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  // Ajout/modification d'une page
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['cle']) || !strlen($_REQUEST['nom']) )
      $message = 'Il n\'est pas possible de valider une page sans clé ou sans nom. Pour supprimer une page, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $cle = $mysqli->real_escape_string($_REQUEST['cle']);
      $nom = $mysqli->real_escape_string($_REQUEST['nom']);
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $bandeau1 = $mysqli->real_escape_string($_REQUEST['bandeau1']);
      $bandeau2 = $mysqli->real_escape_string($_REQUEST['bandeau2']);
      // Si n > 0 : modification d'une page existante. Si n = 0, nouvelle page
      if ( $n )
        $message = ( $mysqli->query("UPDATE pages SET cle = '$cle', nom = '$nom', titre = '$titre',
                                     bandeau1 = '$bandeau1', bandeau2 = '$bandeau2' WHERE id = $n")
        ) ? "La page «&nbsp;$nom&nbsp;» a bien été modifiée." : "La page «&nbsp;$nom&nbsp;» n'a pas pu être modifiée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      else
        $message = ( $mysqli->query("INSERT INTO pages SET cle = '$cle', nom = '$nom', titre = '$titre',
                                     bandeau1 = '$bandeau1', bandeau2 = '$bandeau2', ordre = ((SELECT MAX(p.ordre) FROM pages AS p)+1)")
                  && $mysqli->query('ALTER TABLE pages ORDER BY ordre')
        ) ? "La page «&nbsp;$nom&nbsp;» a bien été ajoutée." : "La page «&nbsp;$nom&nbsp;» n'a pas pu être ajoutée. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
    }
  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = 'pages';
$t = 'Modifications des pages d\'informations du site';
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Description et formulaire vide pour ajout
?>
  <div class="item">
    <p>Les différentes pages d'informations peuvent être définies ici. Il est possible de créer autant de pages que l'on souhaite. Elles apparaîtront ensuite dans le menu et il sera possible d'y mettre des informations.</p>
  </div>

  <form action="" method="post" class="item admin">
    <h3>Ajout d'une nouvelle page</h3>
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
    <h4>Titre&nbsp;: <input type="text" name="titre" value="" size="60"></h4>
    <h4>Nom (dans le menu)&nbsp;: <input type="text" name="nom" value="" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="" size="20">
    </h4>
    <h4>Bandeau de présence d'informations&nbsp;:</h4>
    <div><textarea name="bandeau1" rows="2" cols="100"></textarea></div>
    <h4>Bandeau d'absence d'informations&nbsp;:</h4>
    <div>
      <textarea name="bandeau2" rows="2" cols="100"></textarea>
      <input type="hidden" name="nmodif" value="0">
    </div>
  </form>

  <div class="item">
    <p>Le titre de la page est ce qui sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos de l'ADS et du TIPE&nbsp;».</p>
    <p>Si le titre est laissé vide, «&nbsp;La <?php echo "$classe du lycée $lycee"; ?>&nbsp;» s'affichera automatiquement pour cette page. Cela peut être utile pour une page d'accueil.</p>
    <p>Le nom sera affiché dans le menu en tant que lien vers la page. Il est censé être un peu plus court que le titre. Par exemple, «&nbsp;Informations ADS/TIPE&nbsp;».</p>
    <p>La clé est un mot-clé qui sera utilisé uniquement dans l'adresse de la page («&nbsp;<code>http://<?php echo $site; ?>/?[clé]</code>&nbsp;»). Il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;tipe&nbsp;».</p>
    <p>Le bandeau de présence est le texte qui sera affiché systématiquement avant la liste des informations s'il y en a. Par exemple, «&nbsp;Dernières informations&nbsp;:&nbsp;». Le bandeau d'absence sera lui affiché si aucune information n'est disponible dans la page. Par exemple, «&nbsp;Cette page est actuellement vide.&nbsp;».</p>
  </div>
  
<?php
// Récupération et affichage des pages
$resultat = $mysqli->query('SELECT id, ordre, cle, nom, titre, bandeau1, bandeau2 FROM pages');
$mysqli->close();
if ( $n = $resultat->num_rows )  {
?>
  <h2>Pages existantes</h2>

  <div class="item">
    <p>Il est possible de modifier les pages existantes. Modifier le titre ou les bandeaux changera l'affichage de la page. Modifier le nom changera le lien vers la page dans le menu.</p>
    <p>Modifier la clé changera l'adresse de la page et pourrait éventuellement affecter des liens qui auraient été écrits à la main (cela est très peu probable). Le lien dans le menu sera automatiquement modifié.</p>
    <p>Si le titre est laissé vide, «&nbsp;La <?php echo "$classe du lycée $lycee"; ?>&nbsp;» s'affichera automatiquement pour cette page. Cela peut être utile pour une page d'accueil.</p>
    <p>Il est aussi possible de modifier l'ordre des pages&nbsp;: cela modifie leur ordre d'apparition dans le menu.</p>
  </div>
  
<?php
  // Suppression possible uniquement si plus d'une page
  $suppr = ( $n > 1 ) ? '<input type="submit" name="suppr" value="Supprimer">' : '';
  // Affichage
  while ( $r = $resultat->fetch_assoc() )  {
    $monte = ( $r['ordre'] > 1 ) ? '<input type="submit" name="monte" value="&uarr;" title="Remonter la page dans l\'ordre d\'apparition dans le menu">' : '';
    echo <<<FIN
  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider">$suppr$monte</p>
    <h4>Titre&nbsp;: <input type="text" name="titre" value="${r['titre']}" size="60"></h4>
    <h4>Nom (dans le menu)&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Clé&nbsp;: <input type="text" name="cle" value="${r['cle']}" size="20">
    </h4>
    <h4>Bandeau de présence d'informations&nbsp;:</h4>
    <div><textarea name="bandeau1" rows="2" cols="100">${r['bandeau1']}</textarea></div>
    <h4>Bandeau d'absence d'informations&nbsp;:</h4>
    <div>
      <textarea name="bandeau2" rows="2" cols="100">${r['bandeau2']}</textarea>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </div>
  </form>


FIN;
  }
  $resultat->free();
}
else
  echo "  <h4 class=\"warning\">Aucune page n'est encore définie.</h4>\n\n";

// Bas de page
include('bas.php');
?>

