<?php
// Sécurité et récupération des données de configuration
// La connexion doit obligatoirement être sécurisée (OK=2).
define('OK',2);
include('debut.php');

// Récupération des matières
$mysqli = premiere_connexion();
$resultat = $mysqli->query("SELECT id, cle, nom FROM matieres");
$mysqli->close();
$select_matieres = '        <option value="0">Toutes matières</option>';
while ( $r = $resultat->fetch_assoc() ) {
  $matieres[$r['id']] = $r['cle'];
  if ( !empty($_REQUEST) && isset($_REQUEST[$r['cle']]) )  {
    $matiere = $r;
    $select_matieres .= "\n        <option value=\"${r['id']}\" selected>${r['nom']}</option>";
  }
  else
    $select_matieres .= "\n        <option value=\"${r['id']}\">${r['nom']}</option>";
}
$resultat->free();
if ( !isset($matiere) )
  $matiere = array('id'=>0,'cle'=>'','nom'=>'Toutes matières');

// Traitement d'un ajout/modification/transformation
if ( isset($_REQUEST['nmodif']) && is_numeric($n = $_REQUEST['nmodif']) )  {
  // Sauvegarde de la table contenant les données
  sauvegarde_mysql('repertoires');
  // Connexion à la base de données
  $mysqli = new mysqli($serveur,"$base-adm",$mdp,$base);
  $mysqli->set_charset('utf8');
  
  // Récupération du répertoire avant modification (sauf si création)
  if ( $n )  {
    $resultat = $mysqli->query("SELECT CONCAT('documents/',IF(m.id,CONCAT(m.cle,'/'),''),r.nom) AS chemin, r.nom
                                FROM repertoires AS r LEFT JOIN matieres AS m ON m.id = r.matiere WHERE r.id = $n");
    if ( $resultat->num_rows )  {
      $r = $resultat->fetch_row();
      $chemin = $r[0];
      $nom = $r[1];
      $resultat->free();
    }
  }
  setlocale(LC_CTYPE, "fr_FR.UTF-8");

  // Suppression
  if ( isset($_REQUEST['suppr']) && isset($chemin) )  {
    // Création d'un répertoire temporaire
    $tmp = '/tmp/'.uniqid();
    while ( is_dir($tmp) )
      $tmp = '/tmp/'.uniqid();
    if ( !mkdir($tmp) )
      $message = "Le répertoire «&nbsp;$nom&nbsp;» n'a pas pu être supprimé, car le répertoire temporaire (/tmp) n'est pas accessible.";
    else  {
      // Déplacement du répertoire dans le répertoire temporaire
      exec('mv '.escapeshellarg($chemin)." $tmp/",$out,$nok);
      if ( $nok )
        $message = "Le répertoire «&nbsp;$nom&nbsp;» n'a pas pu être supprimé, car il n'a pas pu être déplacé dans le répertoire temporaire. Résultat de la commande <code>mv</code> : $nok.";
      // Écriture MySQL
      elseif ( $mysqli->query("DELETE FROM repertoires WHERE id = $n") && $mysqli->query("DELETE FROM documents WHERE repertoire = $n") )
        $message = "Le répertoire «&nbsp;$nom&nbsp;» a bien été supprimé.";
      else  {
        // Retour en arrière
        exec("mv $tmp/".escapeshellarg(basename($chemin)).' '.escapeshellarg($chemin));
        $message = "Le répertoire «&nbsp;$nom&nbsp;» n'a pas été supprimé à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
      }
      exec("rm -rf $tmp");
    }
  }

  // Création/déplacement d'un répertoire
  elseif ( isset($_REQUEST['valid_modif']) )  {
    if ( !strlen($_REQUEST['nom']) || !strlen($_REQUEST['titre']) )
      $message = 'Il n\'est pas possible de valider un répertoire sans nom ou sans titre. Pour supprimer un répertoire, il faut cliquer sur Supprimer.';
    else  {
      // Vérifications des données envoyées
      $nom_nouveau = preg_replace('#[\x00-\x1F\x7F-\x9F/\\\\]#','',basename($_REQUEST['nom']));
      $titre = $mysqli->real_escape_string($_REQUEST['titre']);
      $mat = ( isset($matieres[$_REQUEST['matiere']]) ) ? array('id'=>$_REQUEST['matiere'],'cle'=>$matieres[$_REQUEST['matiere']]) : array('id'=>0,'cle'=>'');
      $chemin_nouveau = ( strlen($mat['cle']) ) ? "documents/${mat['cle']}/$nom_nouveau" : "documents/$nom_nouveau";
      umask(0000);

      // Déplacement d'un répertoire existant
      if ( isset($chemin) )  {
        // Vérification que le répertoire n'est pas déplacé à une place déjà prise
        if ( ( $chemin != $chemin_nouveau ) && file_exists($chemin_nouveau) )
          $message = "Le document «&nbsp;$nom&nbsp;» n'a pas été déplacé car un autre répertoire existe à l'endroit demandé.";
        else  {
          // Pas de déplacement
          if ( $chemin == $chemin_nouveau )
            $nok = 0;
          // Déplacement du répertoire à la destination
          else  {
            // Si changement de matière, il faut vérifier que le répertoire correspondant existe ou le créer
            if ( ( $mat['id'] != $matiere['id'] ) && !is_dir(dirname($chemin_nouveau)) )
              mkdir(dirname($chemin_nouveau),0775);
            // Déplacement du répertoire à la destination
            exec('mv '.escapeshellarg($chemin).' '.escapeshellarg($chemin_nouveau),$out,$nok);
          }
          if ( $nok )
            $message = "Le répertoire «&nbsp;$nom&nbsp;» n'a pas été déplacé. Résultat de la commande <code>mv</code> : $nok.";
          // Écriture MySQL
          elseif ( $mysqli->query('UPDATE repertoires SET nom = \''.$mysqli->real_escape_string($nom_nouveau)."', matiere = ${mat['id']}, titre = '$titre' WHERE id = $n")
                && $mysqli->query('ALTER TABLE repertoires ORDER BY matiere,titre') )
            $message = "Les modifications sur le répertoire «&nbsp;$nom&nbsp;» ont bien été prises en compte.";
          else  {
            // Retour en arrière
            if ( $chemin == $chemin_nouveau )
              $message = "Les modification sur le répertoire «&nbsp;$nom&nbsp;» n'ont pas été prises en compte. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
            else  {
              exec('mv '.escapeshellarg($chemin_nouveau).' '.escapeshellarg($chemin));
              $message = "Le répertoire «&nbsp;$nom&nbsp;» n'a pas été déplacé à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
            }
          }
        }
      }

      // Nouveau répertoire : on ne dit rien si le répertoire existe déjà en vrai mais pas dans la base de données
      elseif ( $n == 0 )  {
        $resultat = $mysqli->query('SELECT id FROM repertoires WHERE nom = \''.$mysqli->real_escape_string($nom_nouveau)."' AND matiere = ${mat['id']}");
        if ( $resultat->num_rows )  {
          $resultat->free();
          $message = "Le répertoire «&nbsp;$nom_nouveau&nbsp;» existe déjà dans la base de données.";
        }
        elseif ( !is_dir($chemin_nouveau) && !mkdir($chemin_nouveau,0775,true) )
          $message = "Le répertoire «&nbsp;$nom_nouveau&nbsp;» n'a pas été créé, la commande <code>mkdir</code> n'a pas fonctionné.";
        // Écriture MySQL
        elseif ( $mysqli->query('INSERT INTO repertoires SET nom = \''.$mysqli->real_escape_string($nom_nouveau)."', matiere = ${mat['id']}, titre = '$titre'")
              && $mysqli->query('ALTER TABLE repertoires ORDER BY matiere,titre') ) 
          $message = "Le répertoire «&nbsp;$nom_nouveau&nbsp;» a bien été créé.";
        else  {
          // Retour en arrière
          rmdir($chemin_nouveau);
          $message = "Le répertoire «&nbsp;$nom_nouveau&nbsp;» n'a pas été créé à cause d'une erreur lors des modifications dans la base de données MySQL. Erreur MySQL n°".$mysqli->errno.', «'.$mysqli->error.'».';
        }
      }
    }
  }
  $mysqli->close();
}

//////////
// HTML //
//////////
// Haut de page et menu
$p = rtrim("repertoires?${matiere['cle']}",'?');
$t = "Création et déplacement de répertoires - ${matiere['nom']}";
$mysqli = new mysqli($serveur,$base,$mdp,$base);
$mysqli->set_charset('utf8');
include('haut.php');

// Affichage du message éventuel
if ( isset($message) )
  echo "  <p class=\"annonce\">$message</p>\n\n";

// Vérification des droits sur le répertoire "documents"
if ( !is_dir('documents') )
  $erreur = 'Le répertoire «&nbsp;documents&nbsp;» n\'existe pas à la racine du site web. Il faut le créer pour pouvoir mettre des documents à l\'intérieur.';
elseif ( !is_readable('documents') || !is_executable('documents') || !is_writable('documents') )
  $erreur = 'Le répertoire «&nbsp;documents&nbsp;» n\'a pas les bons droits d\'accès. Il doit être accessible en lecture et en écriture. Vous pouvez taper en console&nbsp;:<br>
  <code>cd '.dirname(__FILE__).' && sudo chgrp '.`id -gn | tr -d '\n'`.' documents && sudo chmod g+w documents</code>'; 
if ( isset($erreur) )  {
  $mysqli->close();
  echo "  <p class=\"annonce\">$erreur</p>\n\n";
  // Bas de page
  include('bas.php');
  exit();
}

// Formulaire pour ajout d'un nouveau répertoire et aide
?>
  <div class="item">
    <p>Vous devez créer ici des répertoires pour pouvoir y envoyer des documents qui seront alors téléchargeables en ligne.</p>
    <p>Si vous choisissez une matière particulière, le répertoire «&nbsp;[nom]&nbsp;» sera à l'emplacement «&nbsp;<code>documents/[matière]/[nom]</code>&nbsp;». Tout document qui y sera mis sera disponible à l'adresse <code>http://<?php echo $site; ?>/documents/[matière]/[nom]/[document]</code>. Le répertoire et son contenu apparaîtront alors sur la page de documents associée à la matière en question.</p>
    <p>Si vous choisissez «&nbsp;Toutes matières&nbsp;», le répertoire «&nbsp;[nom]&nbsp;» sera à l'emplacement «&nbsp;<code>documents/[nom]</code>. Tout document qui y sera mis sera disponible à l'adresse <code>http://<?php echo $site; ?>/documents/[nom]/[document]</code>. Le répertoire et son contenu apparaîtront alors sur la page de documents du menu général. Cela correspond aux documents généraux comme le trombinoscope, le colloscope, l'emploi du temps... On pourra par exemple créer les répertoires «&nbsp;planning&nbsp;», «&nbsp;organisation&nbsp;», «&nbsp;administration&nbsp;»...</p>
  </div>

  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"></p>
    <h3>Création d'un répertoire</h3>
    <h4>Nom&nbsp;: <input type="text" name="nom" value="" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Titre&nbsp;: <input type="text" name="titre" value="" size="40"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Matière&nbsp;:
      <select name="matiere">
<?php echo $select_matieres; ?>
      </select>
      <input type="hidden" name="nmodif" value="0">
    </h4>
  </form>
  
  <div class="item">
    <p>Le nom du répertoire est le nom réel du répertoire où sont stockés les documents (ex: «&nbsp;ds&nbsp;»). Le titre est ce qui apparaît sur la page de téléchargements de la partie publique du site (ex: «&nbsp;Devoirs surveillés&nbsp;»).</p>
    <p>Le nom est souvent un mot unique, court et sans majuscule ni accent, même si les accents et espaces ne sont pas réellement gênants. Le titre devrait commencer par une majuscule et n'a aucune limitation.</p> 
    <p>Ce répertoire sera un sous-répertoire de la matière choisie. Il n'apparaîtra, avec son contenu, que sur la page de téléchargement de la matière en question.</p>
  </div>

<?php
// Récupération et affichage des répertoires
$resultat = $mysqli->query("SELECT r.id, r.nom, r.titre, r.matiere, COUNT(d.id) AS n
                            FROM repertoires AS r LEFT JOIN documents AS d ON d.repertoire = r.id
                            WHERE r.matiere = ${matiere['id']} GROUP BY r.id ORDER BY r.nom");
$mysqli->close();
if ( $resultat->num_rows )  {
  echo <<<FIN
  <h2>Répertoires existants (${matiere['nom']})</h2>
  
  <div class="item">
    <p>Les répertoires déjà existants sont modifiables. Modifier le nom d'un répertoire va le déplacer avec son contenu, modifier les adresses pour télécharger les documents, mais ne rien changer à l'affichage sur le site. Modifier le titre d'un répertoire changera au contraire l'affichage sur le site, mais pas les adresses de téléchargement des documents. Enfin, modifier la matière associée à un répertoire a pour conséquence de le déplacer, de changer les adresses des documents et l'affichage du site (le répertoire apparaît alors dans la matière où il a été déplacé).</p>
  </div>


FIN;
  while ( $r = $resultat->fetch_assoc() )  {
    $note = ( $r['n'] > 1 ) ? 'documents' : 'document';
    $note = ( $r['n'] ) ? "\n    <p class=\"note\">Note&nbsp;: Attention, ce répertoire contient ${r['n']} $note. Il seront tous effacés si vous le supprimez.</p>" : '';
    echo <<<FIN
  <form action="" method="post" class="item admin">
    <p class="bouton_ok"><input type="submit" name="valid_modif" value="Valider"><input type="submit" name="suppr" value="Supprimer"></p>
    <h4>Nom&nbsp;: <input type="text" name="nom" value="${r['nom']}" size="30"> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      Titre&nbsp;: <input type="text" name="titre" value="${r['titre']}" size="40">
    </h4>
    <h4>Matière&nbsp;:
      <select name="matiere">
$select_matieres
      </select>
      <input type="hidden" name="nmodif" value="${r['id']}">
    </h4>$note
  </form>


FIN;
  }
  $resultat->free();
}
else  {
  if ( $matiere['id'] )
    echo "  <h2>Aucun répertoire n'existe encore pour la matière ${matiere['nom']}.</h2>\n\n";
  else
    echo "  <h2>Aucun répertoire n'existe encore pour les documents généraux «&nbsp;toutes matières&nbsp;».</h2>\n\n";
}

// Bas de page
include('bas.php');
?>

